"use strict";

var mqtt = require('mqtt')
var hex_md5 = require('md5');

var device = "esp32_807A98"
var broker_addr = "mqtt.lab"
var broker_port = 1883
var src = "mysrc"
var username = "bob"
var password = "hello"

var client  = mqtt.connect('mqtt://mqtt.lab')
 
client.on('connect', function () {
    client.subscribe(src+'/rpc', function (err) {
        if (!err) {
            // method (and src) needs to be recalled later on error response
            var msg = {
                src: src,
	        id: 456,
	        method: "FS.List"
            };
            client.publish(device+'/rpc', JSON.stringify(msg))
        }
    })
})
 
client.on('message', function (topic, message) {
//  console.log("Received: '" + message.toString() + "'");
    var msg = JSON.parse(message.toString());
    if(msg.hasOwnProperty('error')){
        var error = msg.error;
        var hint = JSON.parse(error.message);
        var method;
        if(error.code === 401){
            switch(msg.id){
            case 456:
                method = "FS.List";
                break;
            }
            var respmsg = {
                src: src,
                id: msg.id,
                method: method,
                auth: dodigest(hint, username, password)
	    }
//            console.log("Response: " + JSON.stringify(respmsg));
            client.publish(device+'/rpc', JSON.stringify(respmsg));
        }
    } else if(msg.hasOwnProperty('result')){
        switch(msg.id){
        case 456:
            process.stdout.write("Listing:\n\t" + JSON.stringify(msg.result) + "\n");
            break;
        }
        client.end()
    }
})

function dodigest(hint, user, pass) {
    var realm = hint.realm;
    var nonce = hint.nonce;
    var nc = hint.nc;
    var cnonce = Math.floor(Math.random() * (2**64));
    var str1 = user + ":" + realm + ":" + pass;
    var ha1 = hex_md5(str1);
    var str2 = "dummy_method:dummy_uri";
    var ha2 = hex_md5(str2);
    var rstr = ha1 + ":" + nonce + ":" + nc + ":" + cnonce + ":auth:" + ha2;
    var response = hex_md5(rstr);
    var respmsg = {
        realm: realm,
        username: user,
        nonce: nonce,
        cnonce: cnonce,
        response: response
    };
    return respmsg;
}
