import paho.mqtt.client as mqtt
import json
import hashlib
import random

device = "esp32_807A98"
broker_addr = "mqtt.lab"
broker_port = 1883
src = "mysrc"
username = "bob"
password = "hello"


def dodigest(hint, user, pwd):
    realm = hint["realm"]
    nonce = hint["nonce"]
    nc = hint["nc"]
    cnonce = str(random.randint(0, (2**64-1)))
    str1 = user + ":" + realm + ":" + pwd
    ha1 = hashlib.md5(str1.encode())
    str2 = "dummy_method:dummy_uri"
    ha2 = hashlib.md5(str2.encode())
    rstr = ha1.hexdigest() + ":" + str(nonce) + ":" + str(nc) + ":" + cnonce + ":auth:" + ha2.hexdigest()
    response = hashlib.md5(rstr.encode())
    respmsg = {
        "realm": realm,
        "username": user,
        "nonce": nonce,
        "cnonce": cnonce,
        "response": response.hexdigest()
    }
    return respmsg


def on_connect(client, userdata, flags, rc):
    print("Connected with result code "+str(rc))

def on_subscribe(client, userdata, mid, granted_qos):
    print("subscribed: " + str(mid) + ", with qos: " + str(granted_qos))
    # method needs to be recalled later on error response
    msg = {
        "src": src,
        "id": 456,
        "method": "FS.List"
    }
    client.publish(device+"/rpc", json.dumps(msg), 1, False)

def on_publish(client, userdata, mid):
    print("published "+str(mid))

def on_message(client, userdata, message):
    msg = json.loads(message.payload.decode("utf-8"))
    handled = False
    msgid = msg["id"]
    if "error" in msg:
        error = msg["error"]
        hint = json.loads(error["message"])
	if error["code"] == 401:
            if msgid == 456:
                method = "FS.List"
            respmsg = {
	        "src": src,
                "id": msgid,
                "method": method,
                "auth": dodigest(hint, username, password)
            }
            client.publish(device+"/rpc", json.dumps(respmsg), 1, False)
	    handled = True
    elif "result" in msg:
        if msgid == 456:
            print("Listing:\n\t" + json.dumps(msg["result"]) + "\n")
            handled = True
    if handled == False:
        print(message.payload.decode("utf-8"))

client = mqtt.Client()
client.on_connect = on_connect
client.on_message = on_message
client.on_subscribe = on_subscribe
client.on_publish = on_publish

client.connect(broker_addr, broker_port)
client.subscribe(src+"/rpc", 1)

# Other loop*() functions are available that give a threaded interface and a
# manual interface.
client.loop_forever()
	
